Introduction
============

MultiBit is a lightweight Bitcoin desktop client powered by the bitcoinj library. 

How to Build MultiBit
=====================

MultiBit use Maven as the build system, so the usual Maven processes apply. If you're not familiar 
with Maven then download it first from http://maven.apache.com and after verifying that it's working,
you're ready. 

Bitcoinj dependency
===================
MultiBit depends on a clone of bitcoinj for its Bitcoin support.
This clone is currently located at:
http://code.google.com/r/jimburton618-bitcoinj-coinbase-tx/source/browse

The branch used is:
bcj-master-mb-alice

You need to clone this repo and then build and install this version of bitcoinj into your local repo using:
mvn clean install

Description of github branches
==============================
There are 2 main branches: master and develop. Master is exclusively for releases. 
Develop is exclusively for release candidates.

Every GitHub Issue gets a branch off develop. When it is complete and code reviewed it is merged into develop. 
The Maven pom.xml maintains a continuous version of develop-SNAPSHOT.

When sufficient Issues are merged into develop to justify a release, a new branch off develop is created with the release number (e.g. release-1.2.3). 
The Maven pom.xml is updated to reflect the snapshot version (e.g. 1.2.3-SNAPSHOT).

Once the release has been tested and is ready to go live, 
the final act is to update the pom.xml to remove the SNAPSHOT suffix and merge it into master. 
The master branch is then tagged with the release number.
Tags are in the format "v1.2.3" to distinguish them from branch names.


Maven build targets
===================
The important targets are:

mvn clean package

which will package the MultiBit project into multibit-x.y.jar where x.y is the current version
number. This is suitable for local development work.

If you want to generate a complete set of multi-platform installers (Windows, Mac and Linux) you 
use the following command

maven clean install

After some processing, you will have the folowing artifacts in the target directory:

+ an executable jar = multibit-exe.jar
+ a Mac application bundle = MultiBit.app
+ a Mac DMG file = multibit-x.y.dmg
+ an installer for Windows = multibit-x.y-windows.exe
+ an installer for Linux = multibit-x.y-linux.jar

To run MultiBit from these artifacts you can follow the instructions provided on the main MultiBit
website here: http://multibit.org/help.html 

Configuration parameters are described in the configuration.txt
